
/*
 *    MCreator note: This file will be REGENERATED on each build.
 */
package net.mcreator.onelaststep.init;

import net.minecraftforge.registries.RegistryObject;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.registries.DeferredRegister;
import net.minecraftforge.fml.event.lifecycle.FMLCommonSetupEvent;
import net.minecraftforge.fml.common.Mod;
import net.minecraftforge.eventbus.api.SubscribeEvent;
import net.minecraftforge.event.entity.EntityAttributeCreationEvent;

import net.minecraft.world.entity.MobCategory;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.Entity;

import net.mcreator.onelaststep.entity.TheCorrupterEntity;
import net.mcreator.onelaststep.entity.SculkZombieEntity;
import net.mcreator.onelaststep.entity.SculkWitherEntity;
import net.mcreator.onelaststep.entity.SculkEntity;
import net.mcreator.onelaststep.OneLastStepMod;

@Mod.EventBusSubscriber(bus = Mod.EventBusSubscriber.Bus.MOD)
public class OneLastStepModEntities {
	public static final DeferredRegister<EntityType<?>> REGISTRY = DeferredRegister.create(ForgeRegistries.ENTITY_TYPES, OneLastStepMod.MODID);
	public static final RegistryObject<EntityType<SculkZombieEntity>> SCULK_ZOMBIE = register("sculk_zombie",
			EntityType.Builder.<SculkZombieEntity>of(SculkZombieEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(SculkZombieEntity::new)

					.sized(0.6f, 1.8f));
	public static final RegistryObject<EntityType<SculkWitherEntity>> SCULK_WITHER = register("sculk_wither",
			EntityType.Builder.<SculkWitherEntity>of(SculkWitherEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(SculkWitherEntity::new)

					.sized(0.6f, 1.7f));
	public static final RegistryObject<EntityType<SculkEntity>> SCULK = register("projectile_sculk",
			EntityType.Builder.<SculkEntity>of(SculkEntity::new, MobCategory.MISC).setCustomClientFactory(SculkEntity::new).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(1).sized(0.5f, 0.5f));
	public static final RegistryObject<EntityType<TheCorrupterEntity>> THE_CORRUPTER = register("the_corrupter",
			EntityType.Builder.<TheCorrupterEntity>of(TheCorrupterEntity::new, MobCategory.MONSTER).setShouldReceiveVelocityUpdates(true).setTrackingRange(64).setUpdateInterval(3).setCustomClientFactory(TheCorrupterEntity::new)

					.sized(0.6f, 1.8f));

	private static <T extends Entity> RegistryObject<EntityType<T>> register(String registryname, EntityType.Builder<T> entityTypeBuilder) {
		return REGISTRY.register(registryname, () -> (EntityType<T>) entityTypeBuilder.build(registryname));
	}

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		event.enqueueWork(() -> {
			SculkZombieEntity.init();
			SculkWitherEntity.init();
			TheCorrupterEntity.init();
		});
	}

	@SubscribeEvent
	public static void registerAttributes(EntityAttributeCreationEvent event) {
		event.put(SCULK_ZOMBIE.get(), SculkZombieEntity.createAttributes().build());
		event.put(SCULK_WITHER.get(), SculkWitherEntity.createAttributes().build());
		event.put(THE_CORRUPTER.get(), TheCorrupterEntity.createAttributes().build());
	}
}
